searchNodes=[{"doc":"OpenaiEx is an Elixir library that provides a community-maintained client for the OpenAI API. The library closely follows the structure of the official OpenAI API client libraries for Python and JavaScript , making it easy to understand and reuse existing documentation and code.","ref":"OpenaiEx.html","title":"OpenaiEx","type":"module"},{"doc":"Sends a GET request to the specified OpenAI API URL endpoint.","ref":"OpenaiEx.html#get/2","title":"OpenaiEx.get/2","type":"function"},{"doc":"Creates a new OpenaiEx struct with the specified token and organization. See https://platform.openai.com/docs/api-reference/authentication for details.","ref":"OpenaiEx.html#new/2","title":"OpenaiEx.new/2","type":"function"},{"doc":"Sends a POST request to the specified OpenAI API URL endpoint with the specified JSON body.","ref":"OpenaiEx.html#post/3","title":"OpenaiEx.post/3","type":"function"},{"doc":"This module provides an implementation of the OpenAI chat completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/chat/completions . API Fields The following fields can be used as parameters when creating a new chat completion: :model :messages :temperature :top_p :n :stream :stop :max_tokens :presence_penalty :frequency_penalty :logit_bias :user","ref":"OpenaiEx.ChatCompletion.html","title":"OpenaiEx.ChatCompletion","type":"module"},{"doc":"Calls the chat completion 'create' endpoint using the given openai configuration and chat_completion request. Arguments openai : The OpenAI configuration. chat_completion : The chat completion request, as a map with keys corresponding to the API fields. Returns A map containing the API response. See https://platform.openai.com/docs/api-reference/chat/completions/create for more information.","ref":"OpenaiEx.ChatCompletion.html#create/2","title":"OpenaiEx.ChatCompletion.create/2","type":"function"},{"doc":"Creates a new chat completion request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the chat completion request. Returns A map containing the fields of the chat completion request. The :model and :messages fields are required. The :messages field should be a list of maps with the OpenaiEx.ChatMessage structure. Example usage: iex&gt; _request = OpenaiEx.ChatCompletion . new ( [ model : &quot;davinci&quot; , messages : [ OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) ] ] ) %{ messages : [ %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; } ] , model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.ChatCompletion . new ( %{ model : &quot;davinci&quot; , messages : [ OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) ] } ) %{ messages : [ %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; } ] , model : &quot;davinci&quot; }","ref":"OpenaiEx.ChatCompletion.html#new/1","title":"OpenaiEx.ChatCompletion.new/1","type":"function"},{"doc":"This module provides an implementation of the OpenAI chat message API. Information about these messages can be found at https://platform.openai.com/docs/guides/chat/introduction . API Fields The following fields can be used as parameters when creating a new chat message: :content :role","ref":"OpenaiEx.ChatMessage.html","title":"OpenaiEx.ChatMessage","type":"module"},{"doc":"Create a ChatMessage map with role assistant . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . assistant ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;assistant&quot; }","ref":"OpenaiEx.ChatMessage.html#assistant/1","title":"OpenaiEx.ChatMessage.assistant/1","type":"function"},{"doc":"Create a ChatMessage map with role system . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . system ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;system&quot; }","ref":"OpenaiEx.ChatMessage.html#system/1","title":"OpenaiEx.ChatMessage.system/1","type":"function"},{"doc":"Create a ChatMessage map with role user . Example usage: iex&gt; _message = OpenaiEx.ChatMessage . user ( &quot;Hello, world!&quot; ) %{ content : &quot;Hello, world!&quot; , role : &quot;user&quot; }","ref":"OpenaiEx.ChatMessage.html#user/1","title":"OpenaiEx.ChatMessage.user/1","type":"function"},{"doc":"This module provides an implementation of the OpenAI completions API. The API reference can be found at https://beta.openai.com/docs/api-reference/completions . API Fields The following fields can be used as parameters when creating a new completion: :model :prompt :suffix :max_tokens :temperature :top_p :n :stream :logprobs :echo :stop :presence_penalty :frequency_penalty :best_of :logit_bias :user","ref":"OpenaiEx.Completion.html","title":"OpenaiEx.Completion","type":"module"},{"doc":"Calls the completion 'create' endpoint using the given openai configuration and completion request. Arguments openai : The OpenAI configuration. completion : The completion request, as a map with keys corresponding to the API fields. Returns A map containing the API response. See https://platform.openai.com/docs/api-reference/completions/create for more information.","ref":"OpenaiEx.Completion.html#create/2","title":"OpenaiEx.Completion.create/2","type":"function"},{"doc":"Creates a new completion request with the given arguments. Arguments args : A list of key-value pairs, or a map, representing the fields of the completion request. Returns A map containing the fields of the completion request. The :model field is required. Example usage: iex&gt; _request = OpenaiEx.Completion . new ( [ model : &quot;davinci&quot; ] ) %{ model : &quot;davinci&quot; } iex&gt; _request = OpenaiEx.Completion . new ( %{ model : &quot;davinci&quot; } ) %{ model : &quot;davinci&quot; }","ref":"OpenaiEx.Completion.html#new/1","title":"OpenaiEx.Completion.new/1","type":"function"},{"doc":"This module provides an implementation of the OpenAI Models API. Information about these models can be found at https://beta.openai.com/docs/models .","ref":"OpenaiEx.Model.html","title":"OpenaiEx.Model","type":"module"},{"doc":"Lists the available models. https://beta.openai.com/docs/api-reference/models/list","ref":"OpenaiEx.Model.html#list/1","title":"OpenaiEx.Model.list/1","type":"function"},{"doc":"Retrieves a specific model by ID. https://beta.openai.com/docs/api-reference/models/retrieve","ref":"OpenaiEx.Model.html#retrieve/2","title":"OpenaiEx.Model.retrieve/2","type":"function"},{"doc":"Mix . install ( [ { :openai_ex , &quot;~&gt; 0.1.0&quot; } ] )","ref":"readme.html","title":"OpenaiEx README","type":"extras"},{"doc":"OpenaiEx is an Elixir library that provides a community-maintained client for the OpenAI API. The library closely follows the structure of the official OpenAI API client libraries for Python and JavaScript , making it easy to understand and reuse existing documentation and code. This file is an executable Livebook, which means you can interactively run and modify the code samples provided. We encourage you to open it in Livebook and try out the code for yourself!","ref":"readme.html#introduction","title":"OpenaiEx README - Introduction","type":"extras"},{"doc":"You can install OpenaiEx using Mix: In Livebook Add the following code to the first connection cell: Mix . install ( [ { :openai_ex , &quot;~&gt; 0.1.0&quot; } ] , ) ` ` ` In a Mix Project Add the following to your mix.exs file: def deps do [ { :openai_ex , &quot;~&gt; 0.1.0&quot; } ] end","ref":"readme.html#installation","title":"OpenaiEx README - Installation","type":"extras"},{"doc":"OpenaiEx provides a thin wrapper around the OpenAI API client, following the same API structure as the official Python and JS clients. To learn how to use OpenaiEx, you can refer to the relevant parts of the official OpenAI API reference documentation, which we link to in the following sections. Authentication To authenticate with the OpenAI API, you will need an API key. We recommend storing your API key in an environment variable, like this: apikey = System . fetch_env! ( &quot;LB_OPENAI_API_KEY&quot; ) openai = OpenaiEx . new ( apikey ) You can also specify an organization if you are a member of more than one: # organization = System.fetch_env!(&quot;LB_OPENAI_ORGANIZATION&quot;) # openai = OpenAIEx.new(apikey, organization) For more information on authentication, see the OpenAI API Authentication reference . Model alias OpenaiEx.Model To list all available models, use the Model.list() function: openai |&gt; Model . list ( ) To retrieve information about a specific model, use the Model.retrieve(model_id) function: openai |&gt; Model . retrieve ( &quot;text-davinci-003&quot; ) For more information on using models, see the OpenAI API Models reference . Completion To generate a completion, you first need to define a completion request structure using the Completion.new() function. This function takes several parameters, such as the model ID, the prompt, the maximum number of tokens, and the temperature. alias OpenaiEx.Completion completion = Completion . new ( model : &quot;text-davinci-003&quot; , prompt : &quot;Say this is a test&quot; , max_tokens : 100 , temperature : 0 ) Once you have defined the completion request structure, you can generate a completion using the Completion.create() function: comp_response = openai |&gt; Completion . create ( completion ) For more information on generating completions, see the OpenAI API Completions reference . Chat Completion alias OpenaiEx.ChatCompletion alias OpenaiEx.ChatMessage To generate a chat completion, you need to define a chat completion request structure using the ChatCompletion.new() function. This function takes several parameters, such as the model ID and a list of chat messages. We have a module ChatMessage which helps in message creation. chat_completion = ChatCompletion . new ( model : &quot;gpt-3.5-turbo&quot; , messages : [ ChatMessage . user ( &quot;Hello&quot; ) ] ) You can generate a chat completion using the ChatCompletion.create() function: chat_response = openai |&gt; ChatCompletion . create ( chat_completion ) For more information on generating chat completions, see the OpenAI API Chat Completions reference .","ref":"readme.html#usage","title":"OpenaiEx README - Usage","type":"extras"}]